%% Lecture 12
clear all
step = 100
%%% Preparing the Laplace Domain
Re = -2e3:step:2e3;
Im = -2e3:step:2e3;
[Res,Ims] = meshgrid(Re,Im);
s = Res + j.*Ims


R = 1e3;
C = 1e-6;
Tau = R*C;

Hnum = 1; % 1
Hden = Tau.*(s+1./Tau);
H = Hnum./Hden;

Hpower = 20.*log10(abs(H)); % powerrr

figure(1)
meshc(Res,Ims,Hpower)
xlabel('Real')
ylabel('Im')
zlabel('H in Power')


%% Ex 3
w = -2e3:step:2e3;% w = 2.*pi.*f
HnumFourier = [1]; % 
HdenFourier = Tau.*[1 1./Tau];

HFourier = freqs(HnumFourier,HdenFourier,w);

HFpower = 20.*log10(abs(HFourier));
HFangle = angle(HFourier).*180./pi; % outputs degrees!

figure(2)
subplot(2,1,1)
semilogx(w,HFpower)
xlabel('Angular Frequency')
ylabel('Power of H')
subplot(2,1,2)
semilogx(w,HFangle)
