%% Lecture 13
clear variables
steppp = 100;
%%% Preparing the Laplace Domain
Re = -2e3:steppp:2e3;
Im = -2e3:steppp:2e3;
[Res,Ims] = meshgrid(Re,Im);
s = Res + 1i.*Ims


R = 1e3;
C = 1e-6;
Tau = R*C;

% Your Transfer function
Hnum = 1/Tau; % 1
Hden = (s+1./Tau);
H = Hnum./Hden;

Hpower = 20.*log10(abs(H)); % powerrr

figure(1)
meshc(Res,Ims,Hpower)
xlabel('Real')
ylabel('Im')
zlabel('H in Power')


%% Ex 3
w = 0:steppp*.1:20e3;% w = 2.*pi.*f
HnumFourier = [1]; % 
HdenFourier = Tau.*[1 1./Tau];

HFourier = freqs(HnumFourier,HdenFourier,w);

HFpower = 20.*log10(abs(HFourier));
HFangle = angle(HFourier).*180./pi; % outputs degrees!

figure(2)
subplot(2,1,1)
semilogx(w,HFpower)
xlabel('Angular Frequency')
ylabel('Power of H')
subplot(2,1,2)
semilogx(w,HFangle)


%% Residuessss

[R,P,K] = residue(HnumFourier,HdenFourier)
t = 0:100e-6:5e-3;
h = R.' * exp(kron(P,t)); 


figure(422)
plot(t,h)
title('Impulse Response pt1')
%% SS Equations

%% Ex 9 - Hand Calcs
% place pic of hand calcs here

%% Exercise 10: Verify in MATLAB

Hn = [1/Tau];
Hd = [1 1/Tau];
[A,B,C,D] = tf2ss(Hn,Hd) % creating SS equations!

%% Exercise 11 - Frequency Response (s-domain)
mySysLOL = ss(A,B,C,D) % my system
w = 0:steppp*.01:20e3; % Angular Frequency!

Hs = freqresp(mySysLOL,w);

HsP = 20.*log10(abs(Hs)); % POer
HsAngle = angle(Hs).*180./pi; % in degrees

figure(6)
subplot(2,1,1)
semilogx(w,squeeze(HsP),'linewidth',2)
title('Power of H(s) using Controls Toolbox')
xlabel('\omega')
ylabel('H(s) in dB')
prettyGraph
subplot(2,1,2)
semilogx(w,squeeze(HsAngle),'linewidth',2)
title('Angle of H(s)')
xlabel('\omega')
ylabel('Angle in degrees')

%% Exercise 12 - Zero, Pole, dcgain

Hzeros = zero(mySysLOL)
Hpoles = pole(mySysLOL)
Hgain = dcgain(mySysLOL)

%% Exercise 14

t = 0:100e-6:5e-3;

ht = impulse(mySysLOL,t);

figure(8)
plot(t,ht)
title('The Impulse Response using SS equations')

%% Exericse 16

stepNum = [0 1];
stepDen = [1 0]; % Equation for unitstep in Laplace domain

stepT = tf(stepNum,stepDen);
stepSys = ss(stepT);

stepResponseSys = mySysLOL*stepSys; % Multiplication! H(s)X(s) = Y(s)

st2 = impulse(stepResponseSys,t);


figure(10)
plot(t,st2)
title('Step Response using Multiplication')



%% Functions
function prettyGraph
% This creates pretty graphs
grid on              % 
ax = gca;             
ax.FontSize = 12;
ax.LineWidth = 3;
set(gcf,'color','w');
end

