%% EE360 Lec. 15 Quiz 10 Problem 1
clear variables
clc
Re = -2:.025:2;
Im = -2:.025:2;

% Setting up the Z-Domain
[Rez,Imz] = meshgrid(Re,Im);
z = Rez + 1i.*Imz; % z!


% Our Transfer Function, H(z)
Hnum = 1 - z.^(-3);
Hden = 1 - z.^(-1);
H = Hnum./Hden;

Hpower = 20.*log10(abs(H)); % Convert to Power  (dB)

figure(1)
meshc(Rez,Imz,Hpower)
xlabel('Real')
ylabel('Im')
zlabel('H in Power')
title('The Transfer Function, $H(z)=\frac{1-z^{-3}}{1-z^{-1}}$','interpreter','latex')
prettyGraph

theta = -2.*pi:0.025:2.*pi;
X = cos(theta);
Y = sin(theta);
Z = 1.*ones(1,length(theta));
w = -2.*pi:.025:2.*pi;


HnumF = [1 0 0 -1];
HdenF = [1 -1 0 0];

HF = freqz(HnumF,HdenF,w);

HFpower = 20.*log10(abs(HF));
hold on
plot3(X,Y,Z,'-k','linewidth',2)
plot3(X,Y,HFpower,'-m','linewidth',3)
hold off
%% Fourier Transforms!
w = -0.*pi:.025:2.*pi;

HnumF = [1 0 0 -1];
HdenF = [1 -1 0 0];
HF = freqz(HnumF,HdenF,w);

HFpower = 20.*log10(abs(HF));
HFangle = angle(HF).*180./pi;

figure(2)
subplot(2,1,1)
plot(w,HFpower,'-m','linewidth',3)
xlabel('Angular Frequency')
ylabel('Power of H')
title('The Frequency Response, $|H(e^{j\omega})|$','interpreter','latex')
xticklabels({'-2\pi' '-1.5\pi' '-\pi' '-0.5\pi' '0'  '.5\pi' '\pi' '1.5\pi' '2\pi'})
xticks([-2*pi -1.5*pi -1*pi -.5*pi 0 .5*pi pi 1.5*pi 2.*pi])
xlim([-0*pi 2*pi])
prettyGraph
subplot(2,1,2)
plot(w,HFangle,'linewidth',2)
title('The Angle of the Frequency Response, $|H(e^{j\omega})|$','interpreter','latex')
xticklabels({'-2\pi' '-1.5\pi' '-\pi' '-0.5\pi' '0'  '.5\pi' '\pi' '1.5\pi' '2\pi'})
xticks([-2*pi -1.5*pi -1*pi -.5*pi 0 .5*pi pi 1.5*pi 2.*pi])
xlim([-0*pi 2*pi])
prettyGraph


%% Rootzzz
zerosH = roots(HnumF)
polesH = roots(HdenF)

fprintf('The zeros of H(z) are located at: ')
fprintf('\nz1 = %f%+fj', real(zerosH(1)), imag(zerosH(1)))
fprintf('\nz2 = %f%+fj and', real(zerosH(2)), imag(zerosH(2)))
fprintf('\nz3 = %f%+fj\n\n', real(zerosH(3)), imag(zerosH(3)))

fprintf('The poles of H(z) are located at: ')
fprintf('\np1 = %f%+fj', real(polesH(1)), imag(polesH(1)))
fprintf('\np2 = %f%+fj and', real(polesH(2)), imag(polesH(2)))
fprintf('\np3 = %f%+fj\n\n', real(polesH(3)), imag(polesH(3)))
fprintf('Note: A double pole exists at z=0!\n\n')

HzN = poly(zerosH)
HzD = poly(polesH)

fprintf('Reconstructing the Transfer Function, H(z): \n')
fprintf('%1.2fz^0 + %1.2fz^-1 + %1.2fz^-2 + %1.2fz^-3\n',HzN(1),HzN(2),HzN(3),HzN(4))
fprintf('----------------------------------------\n')
fprintf('%1.2fz^0 + %1.2fz^-1 + %1.2fz^-2 + %1.2fz^-3\n',HzD(1),HzD(2),HzD(3),HzD(4))

%% The tf2zp Function

figure(3)
zplane(HnumF,HdenF)
title('The System, H(z)')
prettyGraph



%% Functions
function prettyGraph
% This creates pretty graphs
grid on              % 
ax = gca;             
ax.FontSize = 11;
ax.LineWidth = 3;
set(gcf,'color','w');
end


