% Gains!
clc
clear variables
b0 = 2;
b1 = 0;
b2 = -3;
a0 = 1;
a1 = -.5;
a2 = 0;

B = [b0,b1,b2];
A = [a0,a1,a2];

preLength = 2; % Equal to the number of delay blocks!
endLength = 50; % Equal to the end of time!

N =-preLength:endLength; % Time!

%  %number of delays!     n=0    % to the end of time!
X = [zeros(1,preLength),   1    ,ones(1,endLength)]; % input

% Allocating memory!
q1 = [zeros(1,preLength),zeros(1,endLength+1)]; % Allocating method 1
q2 = [zeros(1,preLength),0,zeros(1,endLength)]; % Allocating method 2
y = [zeros(1,abs(N(1))),zeros(1,N(end)+1)];     % Allocating method 3

% Transposed Direct Form II
for i = preLength+1 : preLength+1 + endLength
    
    y(1,i) = b0.*X(1,i) + q1(1,i);
    q1(1,i+1) = -a1.*b0.*X(1,i) -a1.*q1(1,i)+q2(1,i);
    q2(1,i+1) = b2.*X(1,i);

end

figure(22)
stem(N,y)
title({'EE360 Quiz 4','TDFII SS Equations'})
xlabel('n')

